% Obcienie wiatrem
% Wprowadzenie danych na podstawie normy PN-EN1991:4
disp('Obcienie wiatrem')
S=5; KT=7;
while S~=1 & S~=2 & S~=3 
    N=imread('F:\Users\aa\Desktop\Mapa.jpg'); % wczytanie pliku graficznego
    image(N); set(gca,'visible','off'); % wyswietlenie grafiki
    S=input('Numer strefy klimatycznej (1, 2, lub 3)    ');
end
while KT~=0 & KT~=1 & KT~=2 & KT~=3 & KT~=4
    NN=imread('F:\Users\aa\Desktop\Kategorie.jpg');
    image(NN); set(gca,'visible','off');
    KT=input('Kategoria terenu (0, 1, 2, 3 lub 4)    ');
end
A=input('Wysoko terenu w metrach n.p.m.    ');
% Dane normowe
if(S==1)
    if(A<=300)
        vb0=22;
        qb0=0.3;
    else
        vb0=22*(1+0.0006*(A-300));
        qb0=0.3*(1+0.0006*(A-300))^2;
    end
elseif(S==2)
    vb0=26;
    qb0=0.42;
elseif(S==3)
    if(A<=300)
    vb0=22;
    qb0=0.30
    else
        vb0=22*(1+0.0006*(A-300));
        qb0=0.3*((1+0.0006*(A-300))^2)*((20000-A)/(20000+A));
    end
end
disp('Podstawowa warto bazowej prdkoci wiatru     '); vb0
disp('Podstawowa warto cisnienia wiatru     '); qb0
 if(KT==0)
     z0=0.003; zmin=1;
 elseif(KT==1)
     z0=0.01; zmin=1;
 elseif(KT==2)
     z0=0.05; zmin=2;
 elseif(KT==3)
     z0=0.3; zmin=5;
 elseif(KT==4)
     z0=1.0; zmin=10;
 end
X=zeros(1, 200);
Y=zeros(1, 200);
zmax=200; Coz=1; Cdir=1; Cseason=1; z0II=0.05; 
for(i=1:zmax)
    if(i<=zmin)
        z=zmin;
    else
        z=i;
    end
    if(KT==0)
        Crz=1.27*(z/10)^(0.11);
        Cez=2.98*(z/10)^(0.176);
    elseif(KT==1)
        Crz=(1.18*((z/10)^(0.13)));
        Cez=(2.78*((z/10)^(0.205)));
    elseif(KT==2)
        Crz=(z/10)^(0.17);
        Cez=2.29*(z/10)^(0.265);
    elseif(KT==3)
        Crz=0.81*(z/10)^(0.19);
        Cez=1.89*(z/10)^(0.26);
    elseif(KT==4)
        Crz=0.62*(z/10)^(0.24);
        Cez=1.47*(z/10)^(0.30);
    end
 % Obliczenia
    vb=Cdir*Cseason*vb0;
    Vmz=Crz*Coz*vb;
    kr=0.19*(z0/z0II)^(0.07);
    kl=1;
    sigmv=kr*kl*vb;
    if(i<=zmin)
        Ivz=max([sigmv/Vmz kl/(Coz*log(zmin/z0))]);
    else
        z=i;
        Ivz=max([sigmv/Vmz kl/(Coz*log(z/z0))]);
    end
    qpz1=(1+7*Ivz)*0.5*1.25*Vmz^2;
    qb=0.5*1.25*vb^2;
    qpz2=Cez*qb;
    qpz=max([qpz1 qpz2]);
    X(i)=qpz;
    Y(i)=z;
    plot(X, Y,'ro')
    xlabel('Warto szczytowa cinienia prdkoci qp [N/m^2]')
    ylabel('Wysoko odniesienia z [m]') 
    title('Obcienie wiatrem') 
    grid on
end

 
 
 
 
 
 
 
 
 
 
 
 